package math.functions;

import math.axes.Ax;
import math.axes.PShape;

import javax.swing.*;
import java.awt.*;

class Funct19 extends JFrame {
    private static final long serialVersionUID = 431281611636634328L;
    public static final int fw = 1000;
    public static final int fh = 1000;

    public static void main(String[] args) {
        SwingUtilities.invokeLater(() -> new Funct19(new AxPanel19()));
    }

    Funct19(JComponent comp) {
        setLayout(null);
        setPreferredSize(new Dimension(fw, fh));
        setBounds((Toolkit.getDefaultToolkit().getScreenSize().width / 2)
                        - (fw / 2),
                (Toolkit.getDefaultToolkit().getScreenSize().height / 2)
                        - (fh / 2), fw, fh);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("Ramka Graficzna");
        setResizable(false);
        JPanel panel = (JPanel) comp;
        panel.setLocation((fw - panel.getWidth()) / 2,
                (fh - panel.getHeight()) / 2);
        add(panel);
        setVisible(true);
    }
}

class AxPanel19 extends JPanel {
    private static final long serialVersionUID = 5218506428064759030L;
    private static final int w = 860;
    private static final int h = 860;
    private static final int offset = 40;

    public AxPanel19() {
        setPreferredSize(new Dimension(w, h));
        setSize(w, h);
        setBackground(Color.WHITE);
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D) g;
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
        //--
        Ax diag1 = new Ax(0, 0, 280, 280, -7, -7, 14, 14, g2, 1, 1, offset);
        diag1.drawGrid(Color.LIGHT_GRAY);
        diag1.drawAx(Color.BLACK, Color.BLACK);
        diag1.drawTitle("Wykres funkcji: y=1/(x^2-4)");
        for (float i = -7f; i < 7f; i += 0.001f) {
            float ii = 1.0f / (float) (Math.pow(i, 2) - 4.0);
            if ((ii < -7) || ii > 7.0) {
            } else {
                diag1.fillPoint(i, 1.0f / (float) (Math.pow(i, 2) - 4.0), 2f,
                        PShape.Circle, Color.BLUE);
            }
        }
        diag1.drawXLegend(true);
        diag1.drawYLegend(true);
    }
}